using APT.BaseData.Domain.Entities.FM;
using APT.BaseData.Domain.Enums;
using APT.Infrastructure.Core;
using APT.MS.Domain.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace APT.MS.Domain.Entities.SE
{
    /// <summary>
    /// 三级安全教育卡
    /// </summary>
    [Description("三级安全教育卡")]
    public class T_SE_THREE_LEVEL_SAFE_EDU_CARD : MesEntityBase
    {
        /// <summary>
        /// 发起时间
        /// </summary>
        [Description("发起时间")]
        [FormFieldTable]
        [FormFieldQuery]
        [FormFieldEdit]
        public DateTime? LAUNCH_TIME { get; set; }
        /// <summary>
        /// 发起部门ID
        /// </summary>
        [Description("发起部门")]
        [FormFieldTable]
        [FormFieldQuery]
        [FormFieldEdit]
        [DataFieldForeignKey("Nav_LaunchDepartment")]
        public Guid? LAUNCH_DEPARTMENT_ID { get; set; }
        /// <summary>
        /// 导航: 发起部门
        /// </summary>
        [Description("导航: 发起部门")]
        public T_FM_DEPARTMENT Nav_LaunchDepartment { get; set; }
        /// <summary>
        /// 发起人员ID
        /// </summary>
        [Description("发起人员")]
        [FormFieldTable]
        [FormFieldQuery]
        [FormFieldEdit]
        [DataFieldForeignKey("Nav_LaunchUser")]
        public Guid? LAUNCH_USER_ID { get; set; }
        /// <summary>
        /// 导航: 发起人员
        /// </summary>
        [Description("导航: 发起人员")]
        public T_FM_USER Nav_LaunchUser { get; set; }
        /// <summary>
        /// 编号
        /// </summary>
        [Description("编号")]
        [CodeRule((int)PFCodeRuleType.三级安全教育卡)]
        [DataFieldLength(50)]
        public string CODE { get; set; }
        /// <summary>
        /// 培训人员
        /// </summary>
        [Description("培训人员")]
        [FormFieldTable]
        [FormFieldQuery]
        [FormFieldEdit]
        [DataFieldForeignKey("Nav_User")]
        public Guid? USER_ID { get; set; }
        /// <summary>
        /// 导航: 发起人员
        /// </summary>
        [Description("培训人员")]
        public T_FM_USER Nav_User { get; set; }
        /// <summary>
        /// 身份证号
        /// </summary>
        [Description("身份证号")]
        [FormFieldTable]
        [FormFieldQuery]
        [FormFieldEdit]
        [DataFieldLength(50)]
        public string ID_CARD_NUMBER { get; set; }
        /// <summary>
        /// 入职时间
        /// </summary>
        [Description("入职时间")]
        [FormFieldTable]
        [FormFieldQuery]
        [FormFieldEdit]
        public DateTime? IN_TIME { get; set; }
        /// <summary>
        /// 部门ID
        /// </summary>
        [Description("部门")]
        [FormFieldTable]
        [FormFieldQuery]
        [FormFieldEdit]
        [DataFieldForeignKey("Nav_Department")]
        public Guid? DEPARTMENT_ID { get; set; }
        /// <summary>
        /// 导航: 部门
        /// </summary>
        [Description("导航: 部门")]
        public T_FM_DEPARTMENT Nav_Department { get; set; }
        /// <summary>
        /// 岗位
        /// </summary>
        [Description("岗位")]
        [FormFieldTable]
        [FormFieldQuery]
        [FormFieldEdit]
        [DataFieldForeignKey("Nav_Post")]
        public Guid? POST_ID { get; set; }
        /// <summary>
        /// 岗位
        /// </summary>
        [Description("岗位")]
        public T_FM_USER_POST Nav_Post { get; set; }
        /// <summary>
        /// 导航: 三级安全教育卡培训记录
        /// </summary>
        [Description("三级安全教育卡培训记录")]
        [FormFieldEdit]
        public ICollection<T_SE_THREE_LEVEL_SAFE_TRAIN_RECORD> Nav_TrainRecordList { get; set; }
        /// <summary>
        /// 状态
        /// </summary>
        [Description("状态")]
        [EnumName("SEThreeLevelSafeTrainStatus")]
        [FormFieldTable]
        [FormFieldQuery]
        public SEThreeLevelSafeTrainStatus STATUS { get; set; }
        [Description("是否发布")]
        [DataFieldIngore]
        public string PUBLISH { get; set; }

        [DataFieldIngore]
        public int IS_OVERTIME { get; set; }
    }
}
